#include<stdio.h>
#include<stdlib.h>

int comparisons;
int max_depth;

void *psearch(void *base, int size, int width, void *element, int (*compare)(void *, void *)) {
	static int depth = 0;

	if(size == 1) {
		int result = compare(base, element);
		comparisons++;
		printf("Comparison %3d : %d\n", result);
		return result ? NULL : base;
	}
	else {
		int half, right;
		void *found;

		half = size / 2;
		right = abs(rand()) % 2;
		if (++depth > max_depth)
			max_depth = depth;
		printf("At depth %d, after %d comparisons, we're going ", depth, comparisons);
		if(right) {
			printf("right.\n");
			found = psearch(base + half * width, size - half, width, element, compare);
			if(! found) {
				printf("At depth %d, after %d comparisons, we failed by going right, let's try left.",
				       comparisons);
				found = psearch(base, half, width, element, compare);
			}
		}
		else {
			printf("left.\n");
			found = psearch(base, half, width, element, compare);
			if(! found) {
				printf("At depth %d, after %d comparisons, we failed by going left, let's try right.",
				       comparisons);
				found = psearch(base + half * width, size - half, width, element, compare);
			}
		}
		--depth;
		return found;
	}
}
